pico-8 cartridge // http://www.pico-8.com
version 8
__lua__
local sprbrd=1
local sprtlk=2
local sprlok=3
local spruse=4
local uispr={36,14,12,46,44,42,38}
local selui=1

-- text data
local buffer={}
local cline=1

-- menu controls
local inmenu=false
local selit=1
local mc={}

-- inventory
local inv={}

-- character names
local chars={4,1}
local sebaid=1
local fatherid=2
local karynaid=3
local janekid=4
local names={"seba","father", "karyna", "miras"}

-- room data
local rooms={}
local cr=1

-- stage of game
local stage=0

function createobj(n,d)
 local o={}
 o.n=n
 o.d=d
 o.s="none"
 o.isdoor=false
 o.ischar=false
 o.isusable=false
 o.ispickable=false
 return o
end

function createitem(n,d,f)
	local o=createobj(n,d)
	o.isusable=true
	o.f=f
	return o
end

function createdoor(n,d,t)
	local o=createobj(n,d)
	o.isdoor=true
	o.t=t
	return o
end

function createchar(n,d)
	local o=createobj(n,d)
	o.ischar=true
	o.c={}
	o.selc=1
	return o
end

function createroom(n,d)
	local r=createobj(n,d)
	r.i={}
	r.l={}
	r.c={}
	return r
end

function preparerooms()

	
	room=createroom("room","my room. it's filled with car parts and flags of my football team.")

	tracksuit=createitem("track suit", "it's my favourite track suit. going to wear it tonight.", tracksuiton)
	tracksuit.ispickable=true
	tracksuit.isusable=false
	add(room.i,tracksuit)

 denaturat=createitem("denaturat", "my father's favourite drink. i use it to bribe him.",usedenaturat)
 denaturat.ispickable=true
 denaturat.isusable=false
 add(room.i,denaturat)

 bed=createobj("bed","it's my bed, there's a 'juggs' magazine on it.")
 poster=createobj("poster","it's a poster of my favourite team, 'f.c. pitchforks'.")
 add(room.i,bed)
 add(room.i,poster)
	
	phone=createitem("phone","my phone. it's a shitty old one, and when it rings it's usually somebody telling me that i owe them something.",usephone)
	add(room.i,phone)
	

	
	add(rooms,room)
	
 garage=createroom("garage", "i'm in the garage. inside stands my golf and my old man's passat.")
 garagedoor=createdoor("inside","door leading back to the house.",1)
 fielddoor=createdoor("outside","door leading outside.",3)
 add(garage.l,garagedoor)
 add(garage.l,fielddoor)
 golf=createitem("golf", "it's my golf. not in great shape, but it drives.",usecar)
 add(garage.i,golf)
 passat=createitem("passat", "it's my old man's car. one day i'll drive one like it.",usepassat)
 add(garage.i,passat)

 jerrycan=createitem("jerry can","it's a jerry can, it can store fuel.",usejerrycan)
 jerrycan.isusable=false
 jerrycan.ispickable=true
 add(garage.i,jerrycan)

 spoiler=createitem("spoiler","it's a spoiler for my golf. can't leave home without it.",usespoiler)
 spoiler.isusable=false
 spoiler.ispickable=true
 add(garage.i,spoiler)

 add(rooms,garage)


 field=createroom("field","it's the field in front of my parent's house. there is an old tractor in the middle of it. my father is standing next to it.")
 indoor=createdoor("inside","door leading inside",2)
 add(field.l,indoor)
 tractor=createitem("tractor", "it's my old man's tractor. the fuel tank is full.",usetractor)
 add(field.i,tractor)

 father=createchar("father", "my father. he's strong and you don't want to get on his bad side.")
 c1={}
 l1={}
 l1.c=sebaid
 l1.t="what's up, dad?"
 l1.f=nil
 
 l2={}
 l2.c=fatherid
 l2.t="i'm so fucking thirsty..."
 c1.f=nil
 add(c1,l1)
 add(c1,l2)
 
 add(father.c,c1)
 add(field.c,father)


 add(rooms,field)

	
	room3=createroom("party","the barn is the place for all the local boys and girls to meet for a party.")
	karyna=createchar("karyna","karyna is a girl i always liked. for some reason she's standing next to mietek.")
	
	mety=createitem("mietek","mietek is a pussy that needs to be taught a lesson one of those days.")
	mety.isusable=false
	add(room3.i,mety)
	
	c1={}
	c1.f=nil
	l0={}
	l0.c=sebaid
	l0.t="hey karyna, what's up? why are you hanging around this loser?"
	l1={}
	l1.c=karynaid
	l1.t="hey seba. i think you should know that i am with mietek now."
	
 add(c1,l0) 
 add(c1,l1)
 add(karyna.c, c1)
 
 c2={}
 c2.f=endgame
 l2={}
 l2.c=karynaid
 l2.t=""
 add(c2,l2)
 add(karyna.c,c2)

	

	
	add(room3.c,karyna)
	add(rooms,room3)
	
	
end

function usecar()  
  for i in all(rooms[cr].i) do
   if (i.n=="golf") then
    if (i.s=="none") then
     txtbuffer(sebaid, "the car is missing a spoiler and fuel.", false)     
    elseif (i.s=="fueled") then
     txtbuffer(sebaid, "the car is missing a spoiler", false)
    elseif (i.s=="withspoiler") then
     txtbuffer(sebaid, "the car is missing fuel.", false)
    elseif (i.s=="withspoilerandfuel") then
     txtbuffer(sebaid,"i got into my car and went to the party.",true)
     cr=4
     txtbuffer(sebaid,rooms[cr].d,true)
    end
    break

   end
  end
end

function usepassat()
 txtbuffer(sebaid, "if i'd try to drive my old man's car, he'd kill me.",true)
end

function usespoiler()
 if (cr==2) then
  txtbuffer(sebaid, "i attached the spoiler to my car.",true)
  for i in all(rooms[cr].i) do
   if (i.n=="golf") then
    if (i.s=="none") then
     i.s="withspoiler"
     txtbuffer(sebaid, "the car just needs fuel now.", true)     
    elseif (i.s=="fueled") then
     i.s="withspoilerandfuel"
     txtbuffer(sebaid, "the car is ready to go.", true) 
    end

   end
  end
  for i in all(inv) do
   if (i.n=="spoiler") then
    del(inv,i)
    break
   end
  end

 else
 txtbuffer(sebaid, "i need to put it on my car.",true)
 end

end

function usejerrycan()
 for i in all(inv) do
  if (i.n=="jerry can") then  
   -- is empty
   if (i.s=="none") then
    if (cr==3) then
     for ci in all(rooms[cr].i) do
      if (ci.n=="tractor") then
       if (ci.s=="available") then
        i.s="full"
        txtbuffer(sebaid, "i filled up the jerry can.",true)
       end
      end
     end
    else
     txtbuffer(sebaid, "it's an empty jerry can.",true)
    end
   -- is full
   elseif (i.s=="full") then
    if (cr==2) then

     for ci in all(rooms[cr].i) do
      if (ci.n=="golf") then
       if (ci.s=="none") then
        ci.s="fueled"
        txtbuffer(sebaid, "the car just needs spoiler now.", true)     
       elseif (i.s=="withspoiler") then
        i.s="withspoilerandfuel"
        txtbuffer(sebaid, "the car is ready to go.", true) 
       end

      end
     end
     del(inv,i)
     break
    else

     txtbuffer(sebaid, "it's a jerry can full of diesel.",true)
    end
   end
  end
 end
end



function usetractor()
  for i in all(rooms[cr].i) do
   if (i.n=="tractor") then
    if (i.s=="available") then
     -- daj ropy
    else
       txtbuffer(fatherid, "don't try to steal diesel from the tractor again!",false)
    end
   end
  end
end

function usedenaturat()
 if (cr==3) then
  txtbuffer(sebaid, "can i get some diesel from the tractor if i give you some denaturat?",false)
  txtbuffer(fatherid, "sure!",false)
  txtbuffer(sebaid, "i give him the alcohol.",true)
  for i in all(inv) do
   if (i.n=="denaturat") then
    del(inv,i)
    break
   end
  end

  for i in all(rooms[cr].i) do
   if (i.n=="tractor") then
    i.s="available"
   end
  end
 else
  txtbuffer(sebaid, "this shit is too strong for me.",true)
 end
end

function unlockjanek()
	janek=createchar("janek","wykidajlo u moryca. ma u mnie dlug wdziecznosci, przedstawilem go jego zonie. a jak zaczela sie robic zrzedliwa, dobremu adwokatowi.")
	c0={}
	c0.f=nil
	l00={}
	l00.c=janekid
	l00.t="kope lat, guslarz! co tam u ciebie? za rzadko tu wpadasz."
	l01={}
	l01.c=sebaid
	l01.t="hej janek. slyszales cos o mlodym duchu ktorego ktos powstrzymuje przed przejsciem?"
	l02={}
	l02.c=janekid
	l02.t="tak, ale... jestes pewien ze chcesz sie w to pchac?"
	add(c0,l00)
	add(c0,l01)
	add(c0,l02)
	add(janek.c,c0)
	
	c1={}
	c1.f=nil
	l10={}
	l10.c=sebaid
	l10.t="przeciez mnie znasz janek, wiesz ze uwielbiam pakowac sie w klopoty."
	l11={}
	l11.c=janekid
	l11.t="tez prawda. w szczegolnosci jak prosi cie ladna dziewczyna. sluchaj, ten duch to nowa spiewaczka don carlosa. przyjechala z malego miasteczka, snila o sukcesie, zainteresowal sie nia capo. wiesz jak jest."
	add(c1,l10)
	add(c1,l11)
	add(janek.c,c1)
	
	c2={}
	c2.f=nil
	l20={}
	l20.c=sebaid
	l20.t="cholera. i co teraz? potrzebuje tych pieniedzy."
	l21={}
	l21.c=janekid
	l21.t="cokolwiek zrobisz, uwazaj na siebie."
	
	add(c2,l20)
	add(c2,l21)
	add(janek.c,c2)
	
	c3={}
	c3.f=endgame
	l3={}
	l3.c=janekid
	l3.t=""
	add(c3,l3)
	add(janek.c,c3)
	add(room3.c,janek)
end

function endgame()
	stage=2
end

function ridetobar()
	txtbuffer(sebaid,"wsiadlem w moj samochod i pojechalem zasiegnac jezyka.",true)
	cr=3
	txtbuffer(sebaid,rooms[cr].d,true)
				
end

function usephone()
	txtbuffer(sebaid, "i have no money left on the account. can only receive calls.", false)					
					
	for i in all(rooms[cr].i) do
		if (i.n=="phone") then
			i.isusable=false
			break
		end
	end
	
	preparedrop()
end


function tracksuiton()
	d1=createdoor("door","door that leads to the rest of the house.",2)
	add(rooms[cr].l,d1)
	txtbuffer(sebaid, "i'm dressed up and ready to go.",true)

 for i in all(inv) do
  if (i.n=="track suit") then
   del(inv,i)
   break
  end
 end

end

function prepareinv()
	selit=1
	for i in all(mc) do
		del(mc,i)
	end
	for i in all(inv) do
		add(mc,i)
	end
end

function preparemenu()
	selit=1
	for i in all(mc) do
		del(mc,i)
	end
	add(mc,rooms[cr])

	for i in all(rooms[cr].i) do
		add(mc,i)
	end
	
	for i in all(rooms[cr].l) do
		add(mc,i)
	end

	for i in all(rooms[cr].c) do
		add(mc,i)
	end
end

function drawbrd(x,y,t)
	if (selui == t-1) then
		pal(7,10)
		pal(13,8)
		pal(6,9)
	end
	spr(uispr[sprbrd], x, y, 2, 2)
	spr(uispr[t], x, y, 2, 2)
	pal()
end

function drawbutton(x,y,t)
	if (selui == t-1) then
		pal(7,10)
		pal(13,8)
		pal(6,9)
	end
	spr(uispr[t], x, y, 2, 2)
	pal()
end

function drawchar(char,left,big)
	size=16
	if (big) size=32
	px=128-size
	if (left) px=0
	sspr(chars[char]*16,0,16,16,px,128-20-size,size,size)
end

items={40,42,44,46}

function drawitem(x,y,t)
		spr(10,x,y, 2, 2)
//		spr(items[t-3],x,y, 2, 2)
end

function drawui()
	-- draw avatars
	for x=0,16 do
		spr(6,x*8,128-16-4)
	end
	-- draw buttons
	for x=0,5 do
		drawbrd(x*16,128-16,x+2)
		drawbutton(x*16, 128-16, x+2)
	end
	-- draw items
	for x=6,7 do
		drawitem(x*16,128-16,7)
	end
end

function txtbuffer(c,t,th)
	local name={}
	name.th=th
	if (th) then
		name.t="["..names[c].."]"
	else
		name.t=names[c]..":"
	end
	add(buffer, name)

	ok=true
	count=0
	while (ok) do
		local nl={}
		nl.th=th
		nl.t="  "
	
		for lc=count,#t do
		
			char=sub(t,lc,lc)
			nl.t=nl.t..char
			count+=1
			if (#nl.t > 31) break
		end
		
		if (#t == count-1) ok=false
		
		add(buffer,nl)
	end
	fftxt()
end

function rbuf(ox, oy)
	local	posx=ox
	local posy=oy
	for i=cline,#buffer do
		if (i>cline+12) break
		l=buffer[i]
		if (l.th) then
			color(1)
		else
			color(5)
		end
		print(l.t, posx, posy)
		
		if (l.th) then
			color(12)
		else
			color(7)
		end
		print(l.t, posx, posy+1)
		posy+=8
	end
end

function _init()
	music(0)
	preparerooms()
	
	txtbuffer(sebaid,"my name is seba. it's friday night and it's time to pick up some girls at the local barn party.",true) 
end

function drawmenu()
	local x=32
	local y=32
	drawbutton(x+24,y-16,selui+1)
	rectfill(x,y,x+64,y+64,1)
	-- render at most 8 items
	menubase=1
	if (menubase < selit - 7) then
		menubase = selit-7
	end
	local c=0
	for i=menubase,#mc do
		c+=1
		if (c>8) break
		col=7
		if (c == selit-menubase+1) then
		 rectfill(x,y,x+64,y+8,9)
			col=1
		end
		print(mc[i].n,x+2,y+2,col)		
		y+=8
	end
	
end

function preparedrop()
	if (selui == 5) then
		prepareinv()
	else
		preparemenu()
	end
end

function _update()
	if stage==0 then
		if (btnp(4)) then
			stage+=1
		end
	elseif stage==1 then	

		if (btnp(0) and selui > 1) then
		-- left button	
			selui-=1
			preparedrop()
			
		elseif (btnp(1) and selui < 6) then
		-- right button
			selui+=1
			preparedrop()
		elseif (btnp(2)) then
		-- up button
			if (inmenu==false and cline > 1) then
				cline -= 1
			elseif (inmenu==true and selit > 1) then
				selit -= 1
			end
		elseif (btnp(3)) then
		-- down button
			if (inmenu==false and cline <#buffer-12) then
				cline += 1
			elseif (inmenu==true and selit < #mc) then
				selit += 1
			end	
		elseif (btnp(4)) then 
		-- use button
			if (inmenu==false) then
				inmenu=true
				preparedrop()
			else
				if (selui == 1) then
				-- investigate item
					txtbuffer(sebaid, mc[selit].d, true)

				elseif (selui == 2) then	
				-- talk to item
					if(mc[selit].ischar==false) then
						txtbuffer(sebaid, "i can't talk to that.", true)
					else
						counter=0
						for i in all(mc[selit].c) do
							counter+=1
							if (counter == mc[selit].selc) then
								for j in all(mc[selit].c[counter]) do
									txtbuffer(j.c,j.t,false)
								end
								if (mc[selit].c[counter].f != nil) then
									mc[selit].c[counter].f()
								end
								break
							end
						end
						if (mc[selit].selc < #mc[selit].c) then
							mc[selit].selc += 1 	
						end
					end
		
				elseif (selui == 3) then
				-- use item
					if(mc[selit].isusable==false) then
						txtbuffer(sebaid, "i can't use that.", true)					
					else
						mc[selit].f()
					end
				elseif (selui ==4) then
				-- pick up an item
					if(mc[selit].ispickable==false) then
						txtbuffer(sebaid, "i can't pick that up.", true)
					else
						for i in all(rooms[cr].i) do
							if (i.n==mc[selit].n) then
								add(inv,i)
								i.isusable=true
								del(rooms[cr].i,i)
								txtbuffer(sebaid, "i took: "..i.n,true)
							break
						end
					end
							
					end
				elseif (selui ==5) then
				-- use item from inventory
						if (#inv > 0) mc[selit].f()
					elseif (selui == 6) then
				-- walk to item
					if (selit==1) then
						txtbuffer(sebaid, "i'm already here.", true)					
					
					elseif (mc[selit].isdoor==false) then
						txtbuffer(sebaid, "i can't go there.", true)					
					else
						cr=mc[selit].t
						txtbuffer(sebaid,rooms[cr].d,true)
					end
				end
				inmenu=false
			end	
		elseif (btnp(5)) then	
			if (inmenu==true) inmenu=false
		end
	end
end

function fftxt()
						cline = #buffer-12
						if (cline < 1) cline=1
end

col=0

function rl()
	cls()
	spr(0,48,64,4,4)
	pal()
	spr(64,28,0,8,8)
	col+=0.1
	pal()
	color(5)
	--print("by maciej 'mantis' kozlowski",10, 118)

	if (flr(col)%2==1) then
		pal()
		pal(6,7)
		color(6)
	else
		pal()
		color(6)
	end
	print("press (z) to start", 30, 110)
end

function rg()
	cls()
	drawui()
	rbuf(0, 0)
	if (inmenu) then
		drawmenu()
	end
end
textupdate=0
wrongcolor=0
function outro()
	cls()
	print("turn the casette to side b",0,0,7)
	print("and press play to continue",0,8,7)
	string="thanks for playing!"
		text_x=64-(#string*5 / 2)
		text_y=62.5
		for lc=0,#string do
			wrongcolor +=1
			char =sub(string,lc,lc)
			pos_x=text_x+lc*5
			pos_y=text_y+sin(textupdate+lc*0.025)*5
			print(char,pos_x,pos_y,0)
			print(char,pos_x,pos_y,wrongcolor)
		end
		textupdate+=0.025
end

function _draw()
	if (stage==0) then
		rl()
	elseif (stage==1) then
		rg()
	else
		outro()
	end
end
__gfx__
00000000000000000000000000000000000000000000000044444444000000000000000000000000dd11dd11dd11dd1100000000000000000000000000000000
00000000000000000000000000000000000000000000000088888888000000000000000000000000d11001100110011d00007777777000000000000000000000
00000005555555500000000000000000000000000000000022222222000000000000000000000000110011001100110d00077007007770000000000000000000
00000550000007777000000000000000000000000000000011111111000000000000000000000000100110011001100100777777777777000000000000000000
00005000000066666600000000000000000000000000000000000000000000000000000000000000d01100110011001100700007700077000000000000000000
00050000000066666600000000000000000000000000000000000000000000000000000000000000d11001100110011d00677777777777000000077770000000
00500000000066666600000000000000000000000000000000000000000000000000000000000000110011001100110d00066666666676000007700007770000
00500000000066666600000000000000000000000000000000000000000000000000000000000000100110011001100100000000000067700070007770007700
00500000000666666660000000000000000000000000000000000000000000000000000000000000d01100110011001100007777777706600700076666000070
00500000000666666660000000000000000000000000000000000000000000000000000000000000d11001100110011d00077000700770000700076066000700
00500000000666666660000000000000000000000000000000000000000000000000000000000000110011001100110d00077777777770000070076666077600
00500000006666666666000000000000000000000000000000000000000000000000000000000000100110011001100100070007000770000007706660766000
00500000006666666666000000000000000000000000000000000000000000000000000000000000d01100110011001100777777777760000000077777600000
00500000006666666666000000000000000000000000000000000000000000000000000000000000d11001100110011d07766666666600000000000000000000
00500000066666666666000000000000000000000000000000000000000000000000000000000000110011001100111d06600000000000000000000000000000
005000000666666666666000000000000000000000000000000000000000000000000000000000001dd11dd11dd11dd500000000000000000000000000000000
00500000066666666666600000000000111111111111111100000000000000000000000000000000000000000000000000000000000000000000000000000000
005000000666666666666000000000001dd0000000000dd100000000000000000000000000000000000000000000000000000000076000000000000000000000
005000000666666666666000000000001d000000000000d100000000000000000000000000000000000000000000000000000000760000000000000000000000
00500000666666666666660000000000100000000000000100000000000000000000000000000000000000777700000000000007600000000000760000000000
00550000666666666666660000000000100000000000000100007777777000000000000000000000000077000066000000000077700000000000076000000000
00550000666666666666660000000000100000000000000100007000006000000000000000000000000700000000600000000777770000000070076000000000
00550000666666666666660000000000100000000000000100007000006070000000000000000000000700000000600000007777777000000077777000000000
00550006666666666666666000000000100000000000000100007000006077000000000000000000000766666666600000076000007600000006667700000000
00550006666000000666666000000000100000000000000100007000777777700000000000000000000777777777600000076000007600000000006770000000
00550006660060660066666000000000000000000000000100007000006676000000000000000000000777777777600000007600076000000000000677000000
00500006660060666066666000000000000000000000000100007000006060000000000000000000000777707777600000000600060000000000000067700000
00500066600000000000066600000000000000000000000100007000006000000000000000000000000777707777600000000007000000000000000006770000
00500066600000000000066600000000000000000000000100007000006000000000000000000000000777777777600000000077700000000000000000660000
000000006000000000006600000000000d000000000000d100007666666000000000000000000000000066666666000000000777660000000000000000000000
000000000660066660066000000000000dd0000000000dd100000000000000000000000000000000000000000000000000000006000000000000000000000000
00000000000000000000000000000000111111111111111100000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000555560000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000055555560000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000055555560000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000555566000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000555600000000000000000000000000055555600000000005560000000000000000000000000000000000000000000000000000000000000000000000000
00005555600000000000000000000000005555555600000000005560000000000000000000000000000000000000000000000000000000000000000000000000
00005556000000000000000555555550055555555560000000005560000000000000000000000000000000000000000000000000000000000000000000000000
00005560000000000000055555555560555566055560000000055556000000000000000000000000000000000000000000000000000000000000000000000000
00005560000000000000055566666660555660055560000000055556000000000000000000000000000000000000000000000000000000000000000000000000
00005556000000000000055500000000555600005560000000555555600000000000000000000000000000000000000000000000000000000000000000000000
00005555555560000000055500000000556000055560000000555555600000000000000000000000000000000000000000000000000000000000000000000000
00005555555555600000055500000000556005555560000005555555560000000000000000000000000000000000000000000000000000000000000000000000
00000555555555560000555555555550555555555556000005555655556000000000000000000000000000000000000000000000000000000000000000000000
00000666665555556000555555555560555555555555600055556005556000000000000000000000000000000000000000000000000000000000000000000000
00000000006665556000555666666660555555666555600055556000555600000000000000000000000000000000000000000000000000000000000000000000
00000000000006556000555000000000555556000555600555560000555600000000000000000000000000000000000000000000000000000000000000000000
00000000000555556000555000000000555560000055600555555555555560000000000000000000000000000000000000000000000000000000000000000000
00000000055555556005555000000000055560000055605555555555555560000000000000000000000000000000000000000000000000000000000000000000
05555005555555666005555555555550055555555555605555666666605556000000000000000000000000000000000000000000000000000000000000000000
05555555555666000005555555555560055555555555605556000000005556000000000000000000000000000000000000000000000000000000000000000000
05555555556000000005556666666660055555555555605560000000005556000000000000000000000000000005000000000000000000000000000000000000
05555555600000000005660000000000005555055556005560000000000556000000000000000000000000000000000000000000000000000000000000000000
00666666000000000000000000000000000000000000000000000000000556000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__gff__
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__map__
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__sfx__
00010000186501a6501c6501b6501b6501c6501a65018650196501b6501f6501d6500f6500d6500d6500f65012650146502065019650166501665016650166500060000600006000060000600006000060000600
001600000f050100001300011000130001c05013050180000e0501c05013000100501c0500c0001805011000100500c000130001f050100000f050100501a0500e0000c0001c0500e000180500e0001000024000
001c00000c600210000c600186002a0002a0000c6001a0001c0001d000210000c5000c6001d0001f000230000c500270002300023000000000c5001d0001e000000000c500100000c500000000c5002300027000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
__music__
03 01424344
03 01424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344
00 41424344

